GETENV(3)

NAME
getenv, putenv, setenv, unsetenv - environment variable functions

LIBRARY
libc

SYNOPSIS
#include <stdlib.h>
char *
getenv(const char *name);
int
setenv(const char *name, const char *value, int overwrite);
int
putenv(const char *string);
void
unsetenv(const char *name);

DESCRIPTION
These functions set, unset and fetch environment variables from the host environment list. For compatibility with differing environment conventions, the given arguments name and value may be appended and prepended, respectively, with an equal sign “=”.

The getenv() function obtains the current value of the environment variable, name. If the variable name is not in the current environment, a null pointer is returned.

The setenv() function inserts or resets the environment variable name in the current environment list. If the variable name does not exist in the list, it is inserted with the given value. If the variable does exist, the argument overwrite is tested; if overwrite is zero, the variable is not reset, otherwise it is reset to the given value.

The putenv() function takes an argument of the form ``name=value'' and is equivalent to:

    setenv(name, value, 1);

The unsetenv() function deletes all instances of the variable name pointed to by name from the list.

RETURN VALUES
The functions setenv() and putenv() return zero if successful; otherwise the global variable errno is set to indicate the error and a -1 is returned.

ERRORS

[ENOMEM]
    The function setenv() or putenv() failed because they were unable to allocate memory for the environment.

SEE ALSO
csh(1), sh(1), execve(2), environ(7)

STANDARDS
The getenv() function conforms to ansiC. The putenv() function conforms to xpg4.

HISTORY
The functions setenv() and unsetenv() appeared in AT&T UNIX. The putenv() function appeared in 4.3BSD Reno.